transform_units_precipitation <- function(data, original_units, new_units,
                                          var_name, freq) {
  if (original_units == "ms-1") {
    if (new_units == "mm") {
      data[[1]]$data <- data[[1]]$data * 3600 * 24 * 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'mm'
    } else if (new_units == "m") {
     data[[1]]$data <- data[[1]]$data * 3600 * 24
     data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm'
    } else if (new_units == "kgm-2s-1") {
     data[[1]]$data <- data[[1]]$data * 1000 
     data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'kg m-2 s-1'
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else if (original_units == "mm") {
    if (new_units == "ms-1") {
      data[[1]]$data <- data[[1]]$data / (3600 * 24 * 1000)
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm s-1'
    } else if (new_units == "m") {
      data[[1]]$data <- data[[1]]$data / 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm'
    } else if (new_units == "kgm-2s-1") {
      data[[1]]$data <- data[[1]]$data / (3600 * 24 )
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'kg m-2 s-1'
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else if (original_units == "m") {
    if (new_units == "ms-1") {
      data[[1]]$data <- data[[1]]$data / (3600 * 24)
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm s-1'
    } else if (new_units == "mm") {
      data[[1]]$data <- data[[1]]$data * 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'mm'
    } else if (new_units == "kgm-2s-1") {
      data[[1]]$data <- data[[1]]$data * 1000 / (3600 * 24) 
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'kg m-2 s-1'
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else if (original_units == "kgm-2s-1") {
    if (new_units == "ms-1") {
      data[[1]]$data <- data[[1]]$data / 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm s-1'
    } else if (new_units == "mm") {
      data[[1]]$data <- data[[1]]$data * 3600 * 24
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'mm'
    } else if (new_units == "m") {
      data[[1]]$data <- data[[1]]$data * 3600 * 24 / 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm'
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else {
    stop("Unknown precipitation units transformation")
  }
  # If monthly data compute the total monthly accumlated
  if (freq == "monthly_mean") { # could it not be mean?
    data[[1]] <- Apply(list(data[[1]]$data, data[[1]]$attrs$Dates), 
                       target_dim = 'time', fun = function(x, y) {
                        date <- as.Date(y, "%Y-%m-%d")
                        num_days <- lubridate::days_in_month(date)
                        res <- x * num_days
                        })$output1
  }
  return(data)
}


